''' NoFastF - Programma per eseguire la convoluzione tra due funzioni discrete'''
import sys
from time import * #per benchmarking

class nofastf:
    '''questo modulo convolve due funzioni discrete'''
 
    def __init__(self, effe, gi):
        self.effe = effe        
        self.gi = gi        
        try:
            f = file(self.effe,'r')
            g = file(self.gi,'r')
        except Exception:
            print 'Errore di i/o: impossibile trovare i file di input'
        else:
            self.effelist = f.readlines()
            f.close()
            self.gilist = g.readlines()
            g.close()
            self.effelistfin = []
            for x in range(len(self.effelist)):
                app = self.effelist[x]
                app2 = app[:len(app)-1] #taglio \n a fine riga
                self.effelistfin.append(app2)
            self.gilistfin = []
            for x in range(len(self.gilist)):
                app = self.gilist[x]
                app2 = app[:len(app)-1] #taglio \n a fine riga
                self.gilistfin.append(app2)

    def __out(self, nomefile):
        try: out = file(nomefile,'w')
        except Exception:
            print 'Errore di i/o: impossibile scrivere il file ', nomefile
        else:
            print 'lunghezza sequenza output = ', len(self.acca)
            for x in range(len(self.acca)):
                out.write(str(self.acca[x])+'\n')
            out.close()
            print 'creato "'+nomefile+'" con successo\n'
        

    def convolvi(self, gen=0):
        '''effettua la convoluzione'''
        self.acca = []
        print 'lunghezza sequenza input  = ', len(self.effelistfin)
        print 'lunghezza sequenza filtro = ', len(self.gilistfin)
        
        for n in range(len(self.effelistfin)+len(self.gilistfin)-1):
#            print 'n =', n
            accattuale = 0
            for k in range(len(self.effelistfin)):
#                print 'k= ',k
                if (n >= k) and (n < k + len(self.gilist)):
#                    print 'n-k= ',n-k
                    accattuale += float(self.effelistfin[k])*float(self.gilistfin[n-k])
            self.acca.append(accattuale)
        if gen:
            self.__out('out.txt')



if __name__=='__main__':
    time1 = clock()
    ex = nofastf("f.txt", "g.txt")
    ex.convolvi(gen=1)
    time2 = clock()
    print 'Ci ho messo %f secondi' % (time2-time1)
#:-
